<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTDU_ParceirosERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTDU_ParceirosERP
 * @subpackage Arrays
 */
class ArrayOfTDU_ParceirosERP extends AbstractStructArrayBase
{
    /**
     * The TDU_ParceirosERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TDU_ParceirosERP[]
     */
    public $TDU_ParceirosERP;
    /**
     * Constructor method for ArrayOfTDU_ParceirosERP
     * @uses ArrayOfTDU_ParceirosERP::setTDU_ParceirosERP()
     * @param \StructType\TDU_ParceirosERP[] $tDU_ParceirosERP
     */
    public function __construct(array $tDU_ParceirosERP = array())
    {
        $this
            ->setTDU_ParceirosERP($tDU_ParceirosERP);
    }
    /**
     * Get TDU_ParceirosERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TDU_ParceirosERP[]|null
     */
    public function getTDU_ParceirosERP()
    {
        return isset($this->TDU_ParceirosERP) ? $this->TDU_ParceirosERP : null;
    }
    /**
     * Set TDU_ParceirosERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TDU_ParceirosERP[] $tDU_ParceirosERP
     * @return \ArrayType\ArrayOfTDU_ParceirosERP
     */
    public function setTDU_ParceirosERP(array $tDU_ParceirosERP = array())
    {
        foreach ($tDU_ParceirosERP as $arrayOfTDU_ParceirosERPTDU_ParceirosERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfTDU_ParceirosERPTDU_ParceirosERPItem instanceof \StructType\TDU_ParceirosERP) {
                throw new \InvalidArgumentException(sprintf('The TDU_ParceirosERP property can only contain items of \StructType\TDU_ParceirosERP, "%s" given', is_object($arrayOfTDU_ParceirosERPTDU_ParceirosERPItem) ? get_class($arrayOfTDU_ParceirosERPTDU_ParceirosERPItem) : gettype($arrayOfTDU_ParceirosERPTDU_ParceirosERPItem)), __LINE__);
            }
        }
        if (is_null($tDU_ParceirosERP) || (is_array($tDU_ParceirosERP) && empty($tDU_ParceirosERP))) {
            unset($this->TDU_ParceirosERP);
        } else {
            $this->TDU_ParceirosERP = $tDU_ParceirosERP;
        }
        return $this;
    }
    /**
     * Add item to TDU_ParceirosERP value
     * @throws \InvalidArgumentException
     * @param \StructType\TDU_ParceirosERP $item
     * @return \ArrayType\ArrayOfTDU_ParceirosERP
     */
    public function addToTDU_ParceirosERP(\StructType\TDU_ParceirosERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TDU_ParceirosERP) {
            throw new \InvalidArgumentException(sprintf('The TDU_ParceirosERP property can only contain items of \StructType\TDU_ParceirosERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TDU_ParceirosERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TDU_ParceirosERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TDU_ParceirosERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TDU_ParceirosERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TDU_ParceirosERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TDU_ParceirosERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TDU_ParceirosERP
     */
    public function getAttributeName()
    {
        return 'TDU_ParceirosERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTDU_ParceirosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
